package com.sf.msg.service;

package ..deTemp.1734795494989;

import cn.hutool.crypto.Mode;
import cn.hutool.crypto.Padding;
import cn.hutool.crypto.symmetric.AES;
import com.smartframework.web.core.http.HttpResponse;
import com.smartframework.web.core.http.IParaHandler;
import com.smartframework.web.core.utils.Constants;
import com.smartframework.web.core.utils.JsonUtil;
import com.smartframework.web.core.utils.ParameterUtils;
import java.io.IOException;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

public class SmsWxRestParaHandler implements IParaHandler {
  static Logger logger = Logger.getLogger(com.sf.msg.service.SmsWxRestParaHandler.class);
  
  public static String baseUrl = "http://pdzdh.js.sgcc.com.cn";
  
  public static String path = "/fa/sendMessage";
  
  public static String operatorId = "tianjinga";
  
  public static String operatorSecret = "zBHiodQCe0C2GFOv";
  
  public static String encryptSecret = "skf%0jfl@ssff#_7";
  
  public static String encryptIv = "0102030405060708";
  
  public static String sigSecret = "n6PWiKDeKiJWTetP";
  
  public String codeFiledName = "Data";
  
  public String formatDateFiled = "TimeStamp";
  
  private AES aes;
  
  private SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
  
  public SmsWxRestParaHandler() {
    baseUrl = Constants.getString("dms.sms.service.url", "http://pdzdh.js.sgcc.com.cn");
    path = Constants.getString("dms.sms.service.path", "/fa/sendMessage");
    encryptIv = Constants.getString("dms.sms.service.iv", "0102030405060708");
    encryptSecret = Constants.getString("dms.sms.service.key", "skf%0jfl@ssff#_7");
    this.aes = new AES(Mode.CBC, Padding.PKCS5Padding, encryptSecret.getBytes());
    this.aes.setIv(new IvParameterSpec(encryptIv.getBytes()));
  }
  
  public String encrypt(Object dataTime, String alarmContent, List<String> phoneArray) {
    Document document = DocumentHelper.createDocument();
    Element root = document.addElement("content");
    root.addAttribute("name", alarmContent);
    Element iphones = root.addElement("iphones");
    for (String phone : phoneArray) {
      Element iphone = iphones.addElement("iphone");
      iphone.addAttribute("name", phone);
    } 
    String alarm_info = String.format("%s", new Object[] { alarmContent });
    if (!ParameterUtils.isEmptyOrNull(dataTime))
      alarm_info = String.format("%s:%s", new Object[] { String.valueOf(dataTime), alarmContent }); 
    List<String> fileContent = new ArrayList<>();
    fileContent.add("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    fileContent.add(String.format("<content name=\"%s\">", new Object[] { alarm_info }));
    fileContent.add("<iphones>");
    for (String onePhone : phoneArray) {
      fileContent.add(String.format("<iphone name=\"%s\"/>", new Object[] { onePhone }));
    } 
    fileContent.add("</iphones>");
    fileContent.add("</content>");
    String content = StringUtils.join(fileContent, "\n");
    logger.debug("明文: " + content);
    try {
      Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
      int blockSize = cipher.getBlockSize();
      byte[] dataBytes = content.getBytes();
      int plaintextLength = dataBytes.length;
      if (plaintextLength % blockSize != 0)
        plaintextLength += blockSize - plaintextLength % blockSize; 
      byte[] plaintext = new byte[plaintextLength];
      System.arraycopy(dataBytes, 0, plaintext, 0, dataBytes.length);
      SecretKeySpec keyspec = new SecretKeySpec(encryptSecret.getBytes(), "AES");
      IvParameterSpec ivspec = new IvParameterSpec(encryptIv.getBytes());
      cipher.init(1, keyspec, ivspec);
      byte[] encrypted = cipher.doFinal(plaintext);
      return URLEncoder.encode((new Base64()).encodeToString(encrypted));
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } 
  }
  
  public Map<String, Object> encodeRequestPara(Map<String, Object> map) throws IOException {
    return map;
  }
  
  public HttpResponse decodeResponse(HttpResponse httpResponse) throws IOException {
    logger.info(String.format("原始内容:\n%s", new Object[] { httpResponse.getContent() }));
    Map<String, Object> responseMap = httpResponse.getContentMapResult();
    String retDataBody = String.valueOf(responseMap.get(this.codeFiledName));
    retDataBody = this.aes.decryptStr(retDataBody).replaceAll("\n", "").replaceAll("\r", "");
    responseMap.put(this.codeFiledName, retDataBody);
    httpResponse.setContent(JsonUtil.getJsonByObject(responseMap));
    logger.info(String.format("解密后内容:\n%s", new Object[] { httpResponse.getContent() }));
    return httpResponse;
  }
}
